/*****************************************************************************
*	Version 3.6
*	Scripts by Jim Robinson
*	Tarrant County College South Campus
*	5301 Campus Dr.
*	Fort Worth, TX 76119
*	jim.robinson-nospam@tccd.edu (remove -nospam)
*	(817) 515-4310
*
*	For use with the ENCompass 3.6 product by Endeavor Information Systems, Inc.
*  	"ENCompass" is a trademark of Endeavor Information Systems, Inc.
*
*	Allows user input to be retained in search forms when clicking the + or -
*	buttons in Basic Search Form or Advanced Search Form
*	Also allows replacement of "Search Native Interface" with the name of
*	the repository begin searched on the object.xsl page.
*	No warranties or guarantees of any kind or implied. use at your own risk.
*	It works for us, so we thought we'd share... ;-)
*
*	Copyright 2005, Tarrant County College ("TCC"). All rights reserved.
*
*  By using this software the USER indicates that he or she 
*  has read, understood and and will comply with the following:
*
*  TCC hereby grants USER permission to use, copy, modify, and
*  distribute this software and its documentation for any 
*  purpose and without fee, provided that:
*
*  1. the above copyright notice appears in all copies of the
*  software and its documentation, or portions thereof, and
*
*  2. a full copy of this notice is included with the software 
*  and its documentation, or portions thereof, and
*
*  3. neither the software nor its documentation, nor portions
*  thereof, is sold for profit.  Any commercial sale or license
*  of this software, copies of the software, its associated
*  documentation and/or modifications of either is strictly
*  prohibited without the prior consent of TCC.
*
*  Title to copyright to this software and its associated
*  documentation shall at all times remain with TCC.  No right
*  is granted to use in advertising, publicity or otherwise any
*  trademark, service mark, or the name of TCC.
*
*  This software and any associated documentation are provided
*  "as is," and TCC MAKES NO REPRESENTATIONS OR WARRANTIES,
*  EXPRESSED OR IMPLIED, INCLUDING THOSE OF MERCHANTABILITY OR
*  FITNESS FOR A PARTICULAR PURPOSE, OR THAT USE OF THE SOFTWARE,
*  MODIFICATIONS, OR ASSOCIATED DOCUMENTATION WILL NOT INFRINGE
*  ANY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER INTELLECTUAL
*  PROPERTY RIGHTS OF A THIRD PARTY. TCC, Tarrant County College,
*  its Regents, officers, and employees shall not be
*  liable under any circumstances for any direct, indirect, special,
*  incidental, or consequential damages with respect to any claim
*  by USER or any third party on account of or arising from the
*  use, or inability to use, this software or its associated
*  documentation, even if TCC has been advised of the possibility
*  of those damages.
*
*****************************************************************************/

/*****************************************************************************
* Changes since version 3.5
* - updated all instructions to work with 3.6
* -	changed deprecated call to HierTest() to HierCookie() in instructions.
* - commented code no longer used in 3.6
* - updated code to reflect altered form names.
*
/****************************************************************************/

/*****************************************************************************
* Changes since version 3
* -	renamed FormatHierTest to FormatHierCookies to better reflect the xsl template
*	purpose.
* -	altered instructions for placement of the FormatHierCookies xsl template 
*	after pls.gif and mns.gif. There is now an additional xsl template in 
*	child_logic.xsl that does not require the FormatHierCookies xsl template.
* -	added support for childbrowse.xsl to setAllChecks()and clearChecks() functions.
* -	added support for Return Results in xxx Order popup and for the
*	Remove Duplicate Hits checkbox.
* -	additional documentation
* -	removed getDatabase() function for changing "Search Native Interface" text.
*	(It's no longer required.)
*
/****************************************************************************/

/*****************************************************************************
*	setChecks()
*	Collects browser cookies, parses them and sets input fields based on the
*	values.
*****************************************************************************/
function setChecks() {
	// fake for Advanced Search Form, querybox for Basic Search Form
	var fake = (document.forms['fake'])?document.forms['fake']:document.forms['querybox'];
	
	
/***************** Begin retrieve cookie values *****************************/
	var checkboxCookieValues = "";
	var checkboxCookies = "";
	var numCheckboxCookies = 0;
	var cookieName = new Array();
	var cookieValue = new Array();
	var hier = new Array();

	// Get the values of the parents and children hierarchies
	hierCookieValues = getCookie("tcc_Hier");
	if(hierCookieValues != null && hierCookieValues != "") {
		hierCookies = hierCookieValues.split(';');
		numHierCookies = hierCookies.length;
		
		for(i=0;i<numHierCookies-1;i++) {
			var thisCookie = "";
			thisCookie = hierCookies[i];
			var object_id = thisCookie.substring(0, thisCookie.indexOf(':'));
			var hier_id = thisCookie.substring(thisCookie.indexOf(':')+1);
			var period1= hier_id.indexOf('.');
			var period2= hier_id.indexOf('.', period1+1);
			var group = "";
			if(period2 != -1) {
				group=hier_id.substring(period1+1, period2);
			} else {
				group=hier_id.substring(period1+1);
			}
			var hierObject = { groupNum:group, value:object_id, checked:"false" };
			hier[i] = hierObject;
		}
	}
	
	// Parse checkbox cookie and store in arrays
	checkboxCookieValues = getCookie("tcc_checks");
	if(checkboxCookieValues != null && checkboxCookieValues != "") {
		checkboxCookies = checkboxCookieValues.split(';');
		numCheckboxCookies = checkboxCookies.length;
		
		for(i=0;i<numCheckboxCookies;i++) {
			var thisCookie = "";
			thisCookie = checkboxCookies[i];
			var index = thisCookie.substring(0, thisCookie.indexOf('='));
			cookieName[index] = index;
			cookieValue[index] = thisCookie.substring(thisCookie.indexOf('=')+1);
		}
	}
/***************** End retrieve cookie values *******************************/	

/***************** Begin set hierarchy checkbox values **********************/
	// Set "Include Library Catalog In Search" checkbox on by default 
	// (we'll uncheck it later if necessary)
	// If you are not using the "Include Library Catalog In Search" checkbox, 
	// comment all lines containing fake.pm_OPC.
	if(fake) {
		fake.pm_OPC.checked=true; 
	}
	
	// Set checkboxes according to cookies
	var currentGroup = 0;
	var theCheck = false;
	
	// Turns the checkbox on first, then turns it off if necessary.
	// Some browsers won't set a false to true
	if(fake){
		for(j=0;j<fake.pm_CL.length; j++) {
			fake.pm_CL[j].checked = true;
			if(cookieName[fake.pm_CL[j].value] != null) {
				if(cookieValue[fake.pm_CL[j].value] == "false") {
					fake.pm_CL[j].checked = false;
				}
			} else {

/*############################# USER SETTING #################################*/	
/************* Set Default Collections Here. **********************************/
// Get the number by clicking the View XML button 
// and looking for the matching <OI>#</OI> tag.

// For no defaults, comment out the first and third lines.
// That is: 
//		//if(fake.pm_CL[j].value != 1) {
//		//}
//		Leave fake.pm_CL[j].checked = false; uncommented (the line between the other two).

// To add more defaults, enter " && " after the number and 
// duplicate the conditional phrase, like this:
// if(fake.pm_CL[j].value != 1 && fake.pm_CL[j].value != 2) {
		
				if(fake.pm_CL[j].value != 1) { // Set Collection 1 Checked By Default
					fake.pm_CL[j].checked = false;	
				}
/************* End Set Default Collections Here. ******************************/
/*############################# USER SETTING #################################*/

			} // end if(cookieName[fake.pm_CL[j].value] != null) {
		

			// If a collection is open and a child in the collection has been changed to
			// the opposite setting of it's parent, this loop maintains the intent of the
			// user by keeping the integrity of the child's state regardless of the parent state.
			for(k=0;k<hier.length;k++) {
				if(hier[k].value == fake.pm_CL[j].value) {
					var thisGroup = hier[k].groupNum;
					if(currentGroup != thisGroup) {
						currentGroup = thisGroup;
						theCheck = fake.pm_CL[j].checked;
					} else {
						if(cookieName[fake.pm_CL[j].value] == null) {
							fake.pm_CL[j].checked = theCheck;
						}
					}
				}
			}
		}
	}
/***************** End set hierarchy checkbox values ************************/
	
/***************** Begin set search criteria input field values *************/
	var cookieValues = "";
	var cookies = "";
	var numCookies = 0;

/*############################# USER SETTING ###############################*/
	// Set default search types. The default is Global Keyword because it is on top!
	// Simply Uncomment the line to be used.
	//document.forms['boolean'].SC1.value= "SKEY";	// Sets First Search Row To Subject Keyword as Default
	//document.forms['boolean'].SC2.value= "NKEY";	// Sets Second Search Row To Name Keyword as Default
	//document.forms['boolean'].SC3.value= "TKEY";	// Sets Third Search Row To Title Keyword as Default
/*############################# USER SETTING ###############################*/
	
	// Number of Records Per Page
	var numPerPage = 25;
	if(document.forms['fake'] && document.forms['fake'].pm_MH) {
		document.forms['fake'].pm_MH.value=numPerPage;  // Advanced Search Form
	} else if(document.forms['querybox'] && document.forms['querybox'].pm_MH) {
		document.forms['querybox'].pm_MH.value=numPerPage; // Basic Search Form
	}
	
	// Get cookies
	cookieValues = getCookie("tcc_values");
	if(cookieValues != null && cookieValues != "") {
		cookies = cookieValues.split(';');
		numCookies = cookies.length;
	}

	// Set fields based on cookie values
	for(i=0;i<numCookies;i++) {
		var bool = document.forms['boolean'];
		var thisCookie = "";
		var thisCookie = cookies[i];
		var cookieName = "";
		var cookieValue = "";
		if(thisCookie.indexOf('=') != -1) {
			cookieName = thisCookie.substring(0, thisCookie.indexOf('='));
			cookieValue = thisCookie.substring(thisCookie.indexOf('=')+1);
		}
		if(bool != null) {	// Advanced Search Form
			if(cookieName != "") {
				if(cookieName == "SA1" && cookieValue != "") {
					bool.SA1.value= unescape(cookieValue);
				}
				if(cookieName == "SA2" && cookieValue != "") {
					bool.SA2.value= unescape(cookieValue);
				}
				if(cookieName == "SA3" && cookieValue != "") {
					bool.SA3.value= unescape(cookieValue);
				}
				if(cookieName == "pm_OPC" && cookieValue != "") {
					if(cookieValue=="false") {
						fake.pm_OPC.checked= false;
					}
				}
				if(cookieName == "SC1" && cookieValue != "") {
					bool.SC1.value= cookieValue;
				}
				if(cookieName == "SC2" && cookieValue != "") {
					bool.SC2.value= cookieValue;
				}
				if(cookieName == "SC3" && cookieValue != "") {
					bool.SC3.value= cookieValue;
				}
				if(cookieName == "Type1" && cookieValue != "") {
					bool.Type1.value= cookieValue;
				}
				if(cookieName == "Type2" && cookieValue != "") {
					bool.Type2.value= cookieValue;
				}
				if(cookieName == "Type3" && cookieValue != "") {
					bool.Type3.value= cookieValue;
				}
				if(cookieName == "AON2" && cookieValue != "") {
					bool.AON2.value= cookieValue;
				}
				if(cookieName == "AON3" && cookieValue != "") {
					bool.AON3.value= cookieValue;
				}
				if(cookieName == "pm_MH" && cookieValue != "") {
					//bool.pm_MH.value= cookieValue;
					document.forms['fake'].pm_MH.value=cookieValue;
				}
				if(cookieName == "pm_USI" && cookieValue != "") {
					//bool.pm_USI.value= cookieValue;
					fake.pm_USI.value= cookieValue;
				}
				if(cookieName == "pm_DDF" && cookieValue != "") {
					if(cookieValue=="false") {
						//bool.pm_DDF.checked = false;
						fake.pm_DDF.checked = false;
					}
				}
			}
		} else {	// Basic Search Form
			if(cookieName != null) {
				if(fake) {
					if(cookieName == "pm_OPC" && cookieValue != "") {
						if(cookieValue=="false") {
							fake.pm_OPC.checked= false;
						}
					}
					if(cookieName == "pm_SC" && cookieValue != "") {
						fake.pm_SC.value= cookieValue;
					}
					if(cookieName == "pm_SA" && cookieValue != "") {
						fake.pm_SA.value= cookieValue;
					}
					if(cookieName == "pm_MH" && cookieValue != "") {
						fake.pm_MH.value= cookieValue;
					}
					if(cookieName == "pm_USI" && cookieValue != "") {
						fake.pm_USI.value= cookieValue;
					}
					if(cookieName == "pm_DDF" && cookieValue != "") {
						if(cookieValue=="false") {
							fake.pm_DDF.checked = false;
						}
					}
				}
			}
		}
	}
/***************** End set search criteria input field values ***************/
}
/***************** End setChecks() ******************************************/


/*****************************************************************************
*	getChecks()
*	Collects information from form input fields and stores the information in
*	cookies for retrieval by the next page.
*****************************************************************************/
function getChecks() {
	// fake for Advanced Search Form, querybox for Basic Search Form
	var fake = (document.forms['fake'])?document.forms['fake']:document.forms['querybox'];
	var bool = document.forms['boolean'];
	
	// Set cookies for checkboxes
	var getChecksLength = fake.pm_CL.length;
	var checkboxValue = "";
	for(i=0;i<getChecksLength; i++) {
		var cookieName = fake.pm_CL[i].value;
		var cookieValue = fake.pm_CL[i].checked;
		checkboxValue = checkboxValue.concat(cookieName + "=" + cookieValue + ";");
		//setCookie(cookieName, cookieValue);
	}
	setCookie("tcc_checks", checkboxValue);
	
	
	// Get value for "Include Library Catalog In Search"
	// If "Include Library Catalog In Search" is not used,
	// comment all lines containing fake.pm_OPC
	var pm_OPC = fake.pm_OPC.checked;
	
	if(bool != null) {	// Advanced Search Form
		
		// Get values for textfields
		var SA1 = escape(bool.SA1.value);
		var SA2 = escape(bool.SA2.value);
		var SA3 = escape(bool.SA3.value);
		
		// Get values for select boxes
		var SC1 = bool.SC1.value;
		var SC2 = bool.SC2.value;
		var SC3 = bool.SC3.value;
		var Type1 = bool.Type1.value;
		var Type2 = bool.Type2.value;
		var Type3 = bool.Type3.value;
		var AON2 = bool.AON2.value;
		var AON3 = bool.AON3.value;
		
		// Number of Records Per Page
		var pm_MH;
		if(bool.pm_MH) {
			pm_MH = bool.pm_MH.value;
		} else if(fake.pm_MH) {
			pm_MH = fake.pm_MH.value;
		}

		// Return Order and Duplicate Hits
		var pm_USI= fake.pm_USI.value;
		var pm_DDF= fake.pm_DDF.checked;
		
		// Store all values as a single string
		var values = 
			"pm_OPC=" + pm_OPC + ";" +
			"SA1=" + SA1 + ";" +
			"SA2=" + SA2 + ";" +
			"SA3=" + SA3 + ";" +
			"SC1=" + SC1 + ";" +
			"SC2=" + SC2 + ";" +
			"SC3=" + SC3 + ";" +
			"Type1=" + Type1 + ";" +
			"Type2=" + Type2 + ";" +
			"Type3=" + Type3 + ";" +
			"AON2=" + AON2 + ";" +
			"AON3=" + AON3 + ";" +
			"pm_MH=" + pm_MH + ";" +
			"pm_USI=" + pm_USI + ";" +
			"pm_DDF=" + pm_DDF + ";" +
			"";
			
	} else {	// Basic Search Form
		var pm_SC = fake.pm_SC.value;
		var pm_SA = fake.pm_SA.value;
		var pm_MH = fake.pm_MH.value;
		var pm_USI= fake.pm_USI.value;
		//var pm_DDF= fake.pm_DDF.checked;
		
		var values = 
			"pm_OPC=" + pm_OPC + ";" +
			"pm_SC=" + pm_SC + ";" +
			"pm_SA=" + pm_SA + ";" +
			"pm_MH=" + pm_MH + ";" +
			"pm_USI=" + pm_USI + ";" +
			//"pm_DDF=" + pm_DDF;
			"";
	}	
	// Set the cookie
	setCookie("tcc_values", values);
}


/*****************************************************************************
*	setCookie() receives the cookie name and value, returns nothing
*	Accepts the name and value for the cookie and sets it in the client's browser.
*	Not using the expiresm path, domain, and secure parameters at this time.
*****************************************************************************/
function setCookie (name, value, expires, path, domain, secure) {
	var currentCookie = name + "=" + escape(value) +
		( (expires) ? "; expires=" + expires.toGMTString() : "") +
		( (path) ? "; path=" + path : "") +
		( (domain) ? "; domain=" + domain : "") +
		( (secure) ? "; secure" : "");
	document.cookie = currentCookie;
}


/*****************************************************************************
*	getCookie() receives the cookie name, returns the cookie value
*	Takes the cookie name, retrieves the cookie from the client's browser
*	and parses the string to return the value.
*****************************************************************************/	
function getCookie(name) {
	var dc = document.cookie;
	var prefix = name + "=";
	var begin = dc.indexOf("; " + prefix);
	if (begin == -1) {
		begin = dc.indexOf(prefix);
		if (begin != 0) return null;
	}
	else
		begin +=2;
	var end = document.cookie.indexOf(";", begin);
	if (end == -1)
		end = dc.length;
	return unescape( dc.substring(begin + prefix.length, end) );
}


/*****************************************************************************
*	deleteCookie() receives the cookie name, returns nothing
*	Sets the expiration date of the cookie to January 1, 1970.
*	This does not work properly in all browsers.
*****************************************************************************/
function deleteCookie(name, path, domain) {
	if( getCookie(name) ) {
		document.cookie = name + "=" + 
			( (path) ? "; path=" + path : "") +
			( (domain) ? "; domain=" + domain : "") +
			"; expires=Thu, 01-Jan-70 00:00:01 GMT";
	}
}

/*****************************************************************************
*	clearChecks() receives nothing, returns nothing
*	Clears all checkboxes, then resets them to default values
*****************************************************************************/
function clearChecks() {
	
	if(document.forms['boolean']) {		// Advanced Search Form
		document.forms['boolean'].reset();
	}
	if(document.forms['querybox']) {	// Basic Search Form
		document.forms['querybox'].reset();
	}
	if(document.forms['fake']) {	// Basic Search Form
		document.forms['fake'].reset();
	}
	if(document.forms['fake'] && document.forms['fake'].pm_OPC) {
		document.forms['fake'].pm_OPC.checked = false;	// Include Library In Search? checkbox
	}
	deleteCookie("tcc_checks");
	deleteCookie("tcc_values");	
	setChecks();
}


/*****************************************************************************
*	resetBasicChecks() receives nothing, returns nothing
*	Clears all checkboxes, then resets them to default values
*****************************************************************************/
function resetBasicChecks(){
	document.forms['boolean'].reset();
	if(document.forms['fake'].pm_OPC != null) {
		document.forms['fake'].pm_OPC.checked = false;
	}
	deleteCookie("tcc_checks");
	deleteCookie("tcc_values");	
	setChecks();
}
	

/*****************************************************************************
*	setAllChecks() receives String (true or false), returns nothing
*	Sets all checkboxes to either true or false.
*****************************************************************************/
function setAllChecks(setting) {
	fake=(document.forms['fake'])?document.forms['fake']:document.forms['querybox'];
	/*if(fake == null) {
		fake = document.forms['querybox'];	// Basic Search Form
	}*/
	for(i=0;i<fake.pm_CL.length; i++) {
		fake.pm_CL[i].checked=setting;
	}
	fake.pm_OPC.checked = setting;
}


/*****************************************************************************
*	setBasicChecks() receives String (true or false), returns nothing
*	Sets all checkboxes to either true or false.
*****************************************************************************/
function setBasicChecks(setting) {
	bool=document.forms['boolean'];
	for(i=0;i<bool.pm_CL.length; i++) {
		bool.pm_CL[i].checked=setting;
	}
	document.forms['fake'].pm_OPC.checked = setting;
}


/*****************************************************************************
*	hierCookie() receives the hier value as indicated by <SETTAGS hier="hx.x">
*	and the object_id as indicated by <OI>x</OI> in the XML, creates a string
*	with these values and stores them in a cookie.
*****************************************************************************/
function hierCookie(hierVal, object_id) {
	var array = getCookie("tcc_Hier");
	if(array == null) {
		array = "";
	}
	array += object_id + ":" + hierVal + ";";
	setCookie("tcc_Hier", array);
}

/*****************************************************************************
*	deleteHierCookie() receives nothing, returns nothing.
*	Expires the cookie containing the "hier" information.
*****************************************************************************/
function removeHierCookie() {
	deleteCookie("tcc_Hier");
}


/*****************************************************************************
*	Opens the ENCompass 3.5 help window
*****************************************************************************/
function openHelp() {
	var url="/help/encwebclienthelp.htm";
	var name="helpWindow";
	var parameters = "width=800,height=600,toolbar=no,location=no,directories=no,status=yes,menubar=no,scrollbars=yes,copyhistory=yes,resizable=yes";
	openWindow(url, name, parameters);
}


/*****************************************************************************
*	openWindow() takes a url and a window name and opens a fully functional
*	window.
*****************************************************************************/
function openWindow(url, name) {
	var parameters = "width=800,height=600,toolbar=yes,location=yes,directories=yes,status=yes,menubar=yes,scrollbars=yes,copyhistory=yes,resizable=yes";
	window.open(url,name,parameters);
}



